#ifndef dc__list_h
#define dc__list_h

/* To make a new list, create 2 pointers: one for the head, one for the
   tail.  Initialize them both to NULL.  Then pass them to loco_list_prepend.
*/

typedef struct d_list d_list_t;

typedef struct d_list_it {
    struct d_list_it *next;
    struct d_list_it *prev;
    void             *data;
} d_list_it_t;

d_list_t* list_new(void);

void list_ref(d_list_t *list);
void list_unref(d_list_t *list);

d_list_it_t* list_prepend(d_list_t *list, void *data);
void list_delete_link(d_list_t *list, d_list_it_t *pos);
void list_move_before(d_list_t *list, d_list_it_t *move, d_list_it_t *before);
void list_remove(d_list_t *list, void *data);

int list_length(d_list_t *list);
d_list_it_t* list_top(d_list_t *list);
d_list_it_t* list_bottom(d_list_t *list);
d_list_it_t* list_nth(d_list_t *list, int n);
d_list_it_t* list_find(d_list_t *list, void *data);

#endif
